<?php
require_once "include_mainfile.php";
require_once INFUSIONS."mod_tracker/include_benc.php";
require_once INFUSIONS."mod_tracker/include_bittorrent.php";

function err($msg) {
	benc_resp(array("failure reason" => array("type" => "string", "value" => $msg)));
	exit;
}

function benc_resp($d) {
	benc_resp_raw(benc(array("type" => "dictionary", "value" => $d)));
}

function benc_resp_raw($x) {
	header("Content-Type: text/plain");
	header("Pragma: no-cache");
	echo $x;
}

$req = "info_hash:peer_id:!ip:port:uploaded:downloaded:left:!event";

foreach (explode(":", $req) as $x) {
	if ($x[0] == "!") {
		$x = substr($x, 1);
		$opt = 1;
	} else {
		$opt = 0;
	}
	if (!isset($_GET[$x])) {
		if (!$opt) err("Missing key");
		continue;
	}
	$GLOBALS[$x] = unesc($_GET[$x]);
}

foreach (array("info_hash","peer_id") as $x) {
	if (strlen($GLOBALS[$x]) != 20) err("invalid $x (".strlen($GLOBALS[$x])." - ".urlencode($GLOBALS[$x]).")");
}

$client_data['validate'] = false;
$client_data['id'] = 0;
$client_data['stat_update'] = false;
$client_data['uploaded'] = 0;
$client_data['downloaded'] = 0;
$guest_access = 1;

$result = dbquery("SELECT * FROM ".DB_PREFIX."users WHERE user_ip='".USER_IP."'");
$numrows = dbrows($result);
if ($numrows != 0) {
	$data = dbarray($result);
	$result = dbquery("SELECT * FROM ".DB_PREFIX."mod_tracker_users WHERE user_id='".$data['user_id']."'");
	if (dbrows($result) == 0) {
		$result = dbquery("INSERT INTO ".DB_PREFIX."mod_tracker_users VALUES ('".$data['user_id']."', '".USER_IP."', '0', '0', 'leecher', 'NOW()')");
	}
	$client_data['id'] = $data['user_id'];
	$client_data['validate'] = true;
	$client_data['update'] = true;
	$client_data['uploaded'] = $data['uploaded'];
	$client_data['downloaded'] = $data['downloaded'];
}

/*
if ($numrows == 0 && $guest_access == 1) {
	$result = dbquery("SELECT * FROM ".DB_PREFIX."mod_tracker_users WHERE user_ip='".USER_IP."'");
	if (dbrows($result) == 0) {
		$result = dbquery("INSERT INTO ".DB_PREFIX."mod_tracker_users VALUES ('0', '".USER_IP."', '0', '0', 'leecher', 'NOW()')");
	}
	$user_validate = true;
	$user_stat_udate = true;
}
*/

if ($client_data['validate'] == false) err("Visit to site ".$settings['siteurl']." Access is closed");

$port = 0 + $port;
$left = 0 + $left;

$rsize = 50;
foreach(array("num want", "numwant", "num_want") as $k) {
	if (isset($_GET[$k])) {
		$rsize = 0 + $_GET[$k];
		break;
	}
}

if (!$port || $port > 0xffff)	err("invalid port");

if (!isset($event)) $event = "";

$seeder = ($left == 0) ? "yes" : "no";

$res = dbquery("SELECT id, banned, seeders + leechers AS numpeers FROM ".DB_PREFIX."mod_tracker_torrents WHERE ".hash_where("info_hash", $info_hash));

$torrent = dbarray($res);
if (!$torrent) err("torrent not registered with this tracker");

$torrentid = $torrent['id'];

$numpeers = $torrent["numpeers"];
$limit = "";
if ($numpeers > $rsize)	$limit = "ORDER BY RAND() LIMIT $rsize";

$res = dbquery("SELECT * FROM ".DB_PREFIX."mod_tracker_peers WHERE torrent = $torrentid AND (1 OR connectable = 'yes') $limit");
$resp = "d".benc_str("interval")."i".$announce_interval."e".benc_str("peers")."l";
unset($self);
while ($row = dbarray($res)) {
	$row["peer_id"] = hash_pad($row["peer_id"]);
	if ($row["peer_id"] === $peer_id) {
		$self = $row;
		continue;
	}
	$resp .= "d".benc_str("ip").benc_str($row["ip"]).benc_str("peer id").benc_str($row["peer_id"]).benc_str("port")."i".$row["port"]."e"."e";
}
$resp .= "ee";

$selfwhere = "torrent='$torrentid' AND ".hash_where("peer_id", $peer_id);

/*
if (!isset($self)){
	//wait time check
	if($left > 0 && $azz["class"] == $site_config["WAIT_CLASS"] ){ //check only leechers and lowest user class
		$gigs = $user["uploaded"] / (1024*1024*1024);
		$elapsed = floor((gmtime() - $torrent["ts"]) / 3600); 
		$ratio = (($user["downloaded"] > 0) ? ($user["uploaded"] / $user["downloaded"]) : 1); 
		if ($ratio == 0 && $gigs == 0) $wait = $site_config["WAITA"];
		elseif ($ratio < $site_config["RATIOA"] || $gigs < $site_config["GIGSA"]) $wait = $site_config["WAITA"];
		elseif ($ratio < $site_config["RATIOB"] || $gigs < $site_config["GIGSB"]) $wait = $site_config["WAITB"];
		elseif ($ratio < $site_config["RATIOC"] || $gigs < $site_config["GIGSC"]) $wait = $site_config["WAITC"];
		elseif ($ratio < $site_config["RATIOD"] || $gigs < $site_config["GIGSD"]) $wait = $site_config["WAITD"];
		else $wait = 0;
		if ($wait)
		if ($elapsed < $wait)
		err("Wait Time (" . ($wait - $elapsed) . " hours) - Visit ".$site_config["SITEURL"]." for more info");
	}
}else{
	$downloaded = 0 + $downloaded;
	$uploaded = 0 + $uploaded;
	if ($user_stat_udate == true && ($uploaded > 0 || $downloaded > 0)) {
		$result = dbquery("UPDATE ".DB_PREFIX."mod_tracker_users SET uploaded=uploaded + $uploaded, downloaded=downloaded + $downloaded WHERE user_id='".$client_data['id']."' AND user_ip='".USER_IP."'");
	}
}
*/

if (!isset($self)) {
	$res = dbquery("SELECT * FROM ".DB_PREFIX."mod_tracker_peers WHERE $selfwhere");
	$row = dbarray($res);
	if ($row) $self = $row;
}

$updateset = array();

if ($event == "stopped") {
	if (isset($self)) {
		dbquery("DELETE FROM ".DB_PREFIX."mod_tracker_peers WHERE $selfwhere");
		if (mysql_affected_rows()) {
			if ($self["seeder"] == "yes")
				$updateset[] = "seeders=seeders - 1";
			else
				$updateset[] = "leechers=leechers - 1";
		}
	}
} else {
	if ($event == "completed") $updateset[] = "times_completed=times_completed + 1";
	if (isset($self)) {
		dbquery("UPDATE ".DB_PREFIX."mod_tracker_peers SET ip=".USER_IP.", port='$port', uploaded='$uploaded' downloaded='$downloaded', to_go='$left', last_action = NOW(), seeder='$seeder', user_id='".$client_data['id']."' WHERE $selfwhere");
		if (mysql_affected_rows() && $self["seeder"] != $seeder) {
			if ($seeder == "yes") {
				$updateset[] = "seeders = seeders + 1";
				$updateset[] = "leechers = leechers - 1";
			} else {
				$updateset[] = "seeders = seeders - 1";
				$updateset[] = "leechers = leechers + 1";
			}
		}
	} else {
		$sockres = @fsockopen(USER_IP, $port, $errno, $errstr, 5);
		if (!$sockres) {
			$connectable = "no";
		} else {
			$connectable = "yes";
			@fclose($sockres);
		}
		$ret = dbquery("INSERT INTO ".DB_PREFIX."mod_tracker_peers VALUES ('$torrentid', '".preg_replace_callback("/./s", "hex_esc", hash_pad($peer_id))."', '".USER_IP."', '$port', '$uploaded', '$downloaded', '$left', '$seeder', NOW(), NOW(), '$connectable', '".$client_data['id']."')");
		if ($ret) {
			if ($seeder == "yes")
				$updateset[] = "seeders = seeders + 1";
			else
				$updateset[] = "leechers = leechers + 1";
		}
	}
}

if ($seeder == "yes") {
	if ($torrent["banned"] != "yes") $updateset[] = "visible = 'yes'";
	$updateset[] = "last_action = NOW()";
}

if (count($updateset)) dbquery("UPDATE ".DB_PREFIX."mod_tracker_torrents SET ".join(",", $updateset)." WHERE id='$torrentid'");
benc_resp_raw($resp);
?>
